
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ReservationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reservations = await db.reservations.create(
            {
                id: data.id || undefined,
        
        start_time: data.start_time
        ||
        null
            ,
            
        end_time: data.end_time
        ||
        null
            ,
            
        party_size: data.party_size
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        note: data.note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await reservations.setRestaurant( data.restaurant || null, {
            transaction,
        });
        
        await reservations.setClient_user( data.client_user || null, {
            transaction,
        });
        
        await reservations.setTable( data.table || null, {
            transaction,
        });
        

        

        

        return reservations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const reservationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                start_time: item.start_time
            ||
            null
            ,
            
                end_time: item.end_time
            ||
            null
            ,
            
                party_size: item.party_size
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                note: item.note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const reservations = await db.reservations.bulkCreate(reservationsData, { transaction });

        // For each item created, replace relation files
        

        return reservations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const reservations = await db.reservations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.start_time !== undefined) updatePayload.start_time = data.start_time;
        
        
        if (data.end_time !== undefined) updatePayload.end_time = data.end_time;
        
        
        if (data.party_size !== undefined) updatePayload.party_size = data.party_size;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.note !== undefined) updatePayload.note = data.note;
        
        
        updatePayload.updatedById = currentUser.id;

        await reservations.update(updatePayload, {transaction});

        
        
        if (data.restaurant !== undefined) {
            await reservations.setRestaurant(
              
              data.restaurant,
              
              { transaction }
            );
        }
        
        if (data.client_user !== undefined) {
            await reservations.setClient_user(
              
              data.client_user,
              
              { transaction }
            );
        }
        
        if (data.table !== undefined) {
            await reservations.setTable(
              
              data.table,
              
              { transaction }
            );
        }
        

        
        

        

        return reservations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reservations = await db.reservations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of reservations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of reservations) {
                await record.destroy({transaction});
            }
        });


        return reservations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const reservations = await db.reservations.findByPk(id, options);

        await reservations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await reservations.destroy({
            transaction
        });

        return reservations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const reservations = await db.reservations.findOne(
            { where },
            { transaction },
        );

        if (!reservations) {
            return reservations;
        }

        const output = reservations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.restaurant = await reservations.getRestaurant({
            transaction
        });
        
        
        output.client_user = await reservations.getClient_user({
            transaction
        });
        
        
        output.table = await reservations.getTable({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.restaurants,
        as: 'restaurant',
        
        where: filter.restaurant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.restaurant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.restaurant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'client_user',
        
        where: filter.client_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.client_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.client_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.restaurant_tables,
        as: 'table',
        
        where: filter.table ? {
          [Op.or]: [
            { id: { [Op.in]: filter.table.split('|').map(term => Utils.uuid(term)) } },
            {
              table_label: {
                [Op.or]: filter.table.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reservations',
                        'note',
                        filter.note,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            start_time: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    end_time: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.start_timeRange) {
                const [start, end] = filter.start_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_time: {
                    ...where.start_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_time: {
                    ...where.start_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.end_timeRange) {
                const [start, end] = filter.end_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    end_time: {
                    ...where.end_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    end_time: {
                    ...where.end_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.party_sizeRange) {
                const [start, end] = filter.party_sizeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    party_size: {
                    ...where.party_size,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    party_size: {
                    ...where.party_size,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.reservations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'reservations',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.reservations.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

